//##########################################################################################################################
// Filename:
//   main.c
// Version:     Letzte Aenderung:     Author:
//  MC-TB 0110     ab 28.04.2008       JS
// Funktionsbeschreibung:
// Initialisierungen, mainloop, Zeitfunktionen, externe ISR-func
//##########################################################################################################################

// Eingebundene Dateien (includes)
 
#include "iocan128.h"
#include "..\hw_api\lib_USART.h"        // def. zur Schnittstelle

//#include <inavr.h>           // intrinsics

// **************************************************************************************************************************
///////////// externals aus TF2000 wegen ParamFunc ///////// !!
#define PORT_PIN_LOW      0     // Port-Pin auf Low setzen
#define PORT_PIN_HIGH     1     // Port-Pin auf High setzen
#define PORT_PIN_EINGANG  0     // Port-Pin auf Eingang schalten
#define PORT_PIN_AUSGANG  1     // Port-Pin auf Ausgang schalten
#define PORT_BYTE_EINGANG 0x00  // Port-Byte auf Eingang schalten
#define PORT_BYTE_AUSGANG 0xFF  // Port-Byte auf Ausgang schalten

extern unsigned char RestartCom(unsigned char Usart, unsigned short Baud, unsigned char dataBits, unsigned char Parity, unsigned char Stopbit);

// **************************************************************************************************************************
// Funktionen
// **************************************************************************************************************************
 
void   InitMcu(char refresh)
{
if(refresh == 0)
  {
  CLKPR = 0x80;   // Change enable
  CLKPR = 0x00;   // volle 16MIP's Versuch 14.3.2006
  SREG =  0;      // Clear  [ 0x80: + Enable_interrupt()]
  }
}

void   InitHardware(char refresh)
{
// unsigned char _t=__get_interrupt_state();
  Disable_interrupt(); // auch wegen read-modify-write

  InitMcu( refresh);
  if(refresh == 0) // wegen sync, kein 'harter refresh' !
  {
    //Init_TC(0);
//    Init_usart0(0);      // CAN-Lib , Hexload
//    Init_usart1(0);      // Feldbus
    //Init_Twi_lib(0);
    //Init_AD(0);         // konfig, aber disabled lassen
    //InitIntrpt(0);      // konfig, aber disabled lassen
    //CL_InitCan(0);      // #undef CL_INIT_MCU : ohne cpu-init.
    PORTE |= 0xf3;      // pull-ups an Eingaenge Achtung, 485-DIR im Int
//    EEP_WRITE_PROTECT;
//    EEP_WRITE_UNPROTECT; // vorab mal
  }
  // Immer / Refresh:
  DDRA = PORT_BYTE_EINGANG;     // 230VAC Eingaenge
  PORTA = 0x0;    // alle Eingaenge ohne Pull-up'S
  PORTB = 0x03;   //  Boot-Eingaenge mit Pull-up'S, Rest out0
  DDRB = ((PORT_BYTE_EINGANG & 0x03) | (PORT_BYTE_AUSGANG & (~0x03)));
  // Rel Ausg
  PORTC = 0;
  DDRC = PORT_BYTE_AUSGANG;
  // Usart1
  DDRD = ((PORT_BYTE_EINGANG & 0x47) | (PORT_BYTE_AUSGANG & (~0x47))); // TWI-Inp.
  PORTD = 0x7F;   // rx0,tx0,Twi,CAN = 1/Pullup; PD7=out0
  // Usart0
  DDRE = ((PORT_BYTE_EINGANG & 0xf1) | (PORT_BYTE_AUSGANG & (~0xf1)));
  PORTE = 0xF3; // (nur RX0,TX0 Pullup ,WP,Tast = ausg.)
//  EEP_WRITE_UNPROTECT; // vorab mal

  DDRF =  PORT_BYTE_EINGANG;
  PORTF = 0xFC; // AD0,1 ohne Pullup

  PORTG = 0x04;     // Powerdown mit Pullup
  DDRG =  ( (PORT_PIN_AUSGANG<<0)   // Rel09
          | (PORT_PIN_AUSGANG<<1)   // Rel10
           | (PORT_PIN_EINGANG<<2)   // POWERDOWN_PIN
          | (PORT_PIN_AUSGANG<<3)   // res
          | (PORT_PIN_AUSGANG<<4) );// res

// in diesem Projekt wird mit interrupts gearbeitet=> immer enablen.
  Enable_interrupt();
}
 

int main (void)
{
  InitHardware(0);
  // Feldbus-init nach Parameter aktual.

  RestartCom(1, 9600, 8, 2, 1); // Parity Gerade/Even    
  
  // *DEBUG Testausgabe Mm                                               
  RestartCom(0, 9600, 8, 2, 1);
    
  while(1)
  {
    Test_Mm();
  }
}

